############################################################################################################################
# Name:        StickyNades v2.0.2                                                                                          #
#                                                                                                                          #
# Author:      JoeyT2008                                                                                                   #
#                                                                                                                          #
# Description: Makes grenades stick to walls and players.                                                                  #
#                                                                                                                          #
#              1. When a grenade sticks to someone, it doesn't stick in the right place yet, it does stick to them though. #
#                                                                                                                          #
# Notes:       1. To make a grenade stick to yourself, aim down and throw a grenade, it will then stick to your feet.      #
#              2. The model for the nade is from TF2, no credit goes to me whatsoever.                                     #
#                                                                                                                          #
# Credits:     Creator         JoeyT2008                                                                                   #
#                                                                                                                          #
#              Idea            JoeyT2008                                                                                   #
#                                                                                                                          #
#              Help            Errant (THANKYOU SO MUCH)                                                                   #
#                              Saul (THANKYOU SO MUCH)                                                                     #
#                              Lobe (BETRAYER)                                                                             #
#                              Ajurna                                                                                      #
#                              Mattie                                                                                      #
#                              Superdave                                                                                   #
#                              Wonder                                                                                      #
#                              GODJonez                                                                                    #
#                              MBChrono                                                                                    #
#                              GLitched System                                                                             #
#                                                                                                                          #
#              Testing         Saul                                                                                        #
#                              mupet0000                                                                                   #
#                              Errant                                                                                      #
#                                                                                                                          #
#              Parent Code     Wonder (from Venjax's emote mod) - Fixed by Errant                                          #
#                                                                                                                          #
#              Nade Model      Valve                                                                                       #
#                                                                                                                          #
#              Various CMD's   Everyone on IRC                                                                             #
############################################################################################################################

import es, gamethread, vecmath, playerlib
from es import server_var

info = es.AddonInfo()
info.name = "StickyNades"
info.version = "2.0.2"
info.author = "JoeyT2008"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=17799"
info.description = "Makes nades stick to walls and players!"
info.basename = "stickynades"

######################
##START EDITING HERE##
######################

# Make frag grenades stick? 1=YES, 0=NO
sn_fragsticky = es.ServerVar("sn_fragsticky", 1, "Makes frag grenades stick")

# Make flashbags stick? 1=YES, 0=NO
sn_flashsticky = es.ServerVar("sn_flashsticky", 1, "Makes flashbangs stick")

# Make grenades stick to walls? 1=YES, 0=NO
sn_sticktowalls = es.ServerVar("sn_sticktowalls", 1, "Makes grenades stick to walls")

# Make grenades stick to players? 1=YES, 0=NO
sn_sticktoplayers = es.ServerVar("sn_sticktoplayers", 1, "Makes grenades stick to players")

# Make grenades stick to the thrower? 1=YES, 0=NO
sn_sticktothrower = es.ServerVar("sn_sticktothrower", 0, "Makes grenades stick to the thrower")

# Play sounds when a player gets stuck? 1=YES, 0=NO
sn_emitsounds = es.ServerVar("sn_emitsounds", 1, "Plays sounds when a player gets stuck")

# Force players to download models, materials and sounds? 1=YES, 0=NO
sn_downloads = es.ServerVar("sn_downloads", 1, "Forces players to download models, materials and sounds")

# Use a custom model for frag grenades? 1=YES, 0=NO
sn_newmodel = es.ServerVar("sn_newmodel", 1, "Uses a custom model for frag grenades")

# Power of a frag grenade when not stuck to a player. (Real damage = 100)
sn_grenadenormalpower = es.ServerVar("sn_grenadenormalpower", 100, "Power of a frag grenade when not stuck to a player")

# Power of a frag grenade when stuck to a player. (Real damage = 100)
sn_grenadestuckpower = es.ServerVar("sn_grenadestuckpower", 300, "Power of a frag grenade when stuck to a player")

# Radius of a frag grenade when not stuck to a player. (Real radius = 350)
sn_grenadenormalradius = es.ServerVar("sn_grenadenormalradius", 350, "Radius of a frag grenade when not stuck to a player")

# Radius of a frag grenade when stuck to a player. (Real radius = 350)
sn_grenadestuckradius = es.ServerVar("sn_grenadestuckradius", 350, "Radius of a frag grenade when stuck to a player")

# Shake when hit by a stickynade?
sn_shake = es.ServerVar("sn_shake", 1, "Shakes screen when hit by a stickynade")

#####################
##STOP EDITING HERE##
#####################

stuck = {}
stickynades = es.ServerVar("stickynades", 1, "Enable/Disable StickyNades")
stickynades_ver = es.ServerVar("stickynades_ver", "2.0.2", "Version of StickyNades that you are using.")
stickynades_ver.makepublic()

def load():
    global sn_dict
    sn_dict = {}
    es.doblock('corelib/noisy_on')
    if not es.ServerVar("eventscripts_currentmap") == "":
        precache()
        downloads()

def downloads():
    es.stringtable('downloadables', 'sound/stickynades/muhahaha.wav')
    es.stringtable('downloadables', 'sound/stickynades/scream.wav')
    es.stringtable('downloadables', 'models/stickynades/stickynades_red.dx80.vtx')
    es.stringtable('downloadables', 'models/stickynades/stickynades_red.dx90.vtx')
    es.stringtable('downloadables', 'models/stickynades/stickynades_red.mdl')
    es.stringtable('downloadables', 'models/stickynades/stickynades_red.phy')
    es.stringtable('downloadables', 'models/stickynades/stickynades_red.sw.vtx')
    es.stringtable('downloadables', 'models/stickynades/stickynades_red.vvd')
    es.stringtable('downloadables', 'models/stickynades/stickynades_blue.dx80.vtx')
    es.stringtable('downloadables', 'models/stickynades/stickynades_blue.dx90.vtx')
    es.stringtable('downloadables', 'models/stickynades/stickynades_blue.mdl')
    es.stringtable('downloadables', 'models/stickynades/stickynades_blue.phy')
    es.stringtable('downloadables', 'models/stickynades/stickynades_blue.sw.vtx')
    es.stringtable('downloadables', 'models/stickynades/stickynades_blue.vvd')
    es.stringtable('downloadables', 'materials/models/stickynades/stickynades_blue.vtf')
    es.stringtable('downloadables', 'materials/models/stickynades/stickynades_blue.vmt')
    es.stringtable('downloadables', 'materials/models/stickynades/stickynades_red.vtf')
    es.stringtable('downloadables', 'materials/models/stickynades/stickynades_red.vmt')

def precache():
    global sn_nademodel_red
    global sn_nademodel_blue
    sn_nademodel_red = es.precachemodel("models/stickynades/stickynades_red.mdl")
    sn_nademodel_blue = es.precachemodel("models/stickynades/stickynades_blue.mdl")

def es_map_start(event_var):
    precache()
    downloads()

def round_start(event_var):
    global stuck
    if stickynades == 1:
        es.msg("#multi", "#green[StickyNades]#lightgreen is running. Created by #greenJoeyT2008")
        if sn_fragsticky == 1 and sn_sticktowalls == 1 and sn_sticktoplayers == 1:
            if sn_sticktowalls == 1:
                if sn_sticktoplayers == 1:
                    es.msg("#multi", "#green[StickyNades]#lightgreen Frag Grenades stick to walls and players.")
                else:
                    es.msg("#multi", "#green[StickyNades]#lightgreen Frag Grenades stick to walls.")
            else:
                 if sn_sticktoplayers == 1:
                     es.msg("#multi", "#green[StickyNades]#lightgreen Frag Grenades stick to players.")
        if sn_flashsticky == 1:
            if sn_sticktowalls == 1:
                if sn_sticktoplayers == 1:
                    es.msg("#multi", "#green[StickyNades]#lightgreen Flashbangs stick to walls and players.")
                else:
                    es.msg("#multi", "#green[StickyNades]#lightgreen Flashbangs stick to walls.")
            else:
                 if sn_sticktoplayers == 1:
                     es.msg("#multi", "#green[StickyNades]#lightgreen Flashbangs stick to players.")
    for sn_userid in playerlib.getPlayerList("#all"):
        if int(sn_userid) in stuck:
            del stuck[int(sn_userid)]

def weapon_fire(event_var):
    global sn_dict
    sn_dict[str(event_var["userid"])] = 3
    if stickynades == 1:
        if sn_fragsticky == 1:
            if event_var["weapon"] == "hegrenade":
                sn_dict[str(event_var["userid"])] = 1
                gamethread.delayed(0.15, stopnade, event_var["userid"])
        if sn_flashsticky == 1:
            if event_var["weapon"] == "flashbang":
                sn_dict[str(event_var["userid"])] = 2
                gamethread.delayed(0.15, stopnade, event_var["userid"])

def stopnade(sn_userid):
    global sn_dict
    if stickynades == 1:
        sn_player = es.getplayerhandle(sn_userid)
        if sn_dict[str(sn_userid)] == 1:
            sn_entlist = es.createentitylist("hegrenade_projectile")
        if sn_dict[str(sn_userid)] == 2:
            sn_entlist = es.createentitylist("flashbang_projectile")
        for sn_temp in sn_entlist:
            sn_string = 0
            sn_string = es.getindexprop(sn_temp, "CBaseGrenade.m_hThrower")
            if sn_string == sn_player:
                 sn_dict["entity_" + str(sn_userid)] = sn_temp
        if sn_dict["entity_" + str(sn_userid)]:
            if sn_dict[str(sn_userid)] == 1:
                es.setindexprop(sn_dict["entity_" + str(sn_userid)], "CBaseGrenade.m_flDamage", sn_grenadenormalpower)
                es.setindexprop(sn_dict["entity_" + str(sn_userid)], "CBaseGrenade.m_DmgRadius", sn_grenadenormalradius)
                sn_userteam = es.getplayerteam(sn_userid)
                if sn_newmodel == 1:
                    if sn_userteam == 2:
                        es.setindexprop(sn_dict["entity_" + str(sn_userid)], "CBaseEntity.m_nModelIndex", sn_nademodel_red)
                    if sn_userteam == 3:
                        es.setindexprop(sn_dict["entity_" + str(sn_userid)], "CBaseEntity.m_nModelIndex", sn_nademodel_blue)
                    es.setindexprop(sn_dict["entity_" + str(sn_userid)], "CBaseEntity.m_clrRender", -1)

def grenade_bounce(event_var):
    global sn_dict
    if stickynades == 1:
        if sn_dict.has_key(str(event_var["userid"])):
            if sn_dict[str(event_var["userid"])] == 1 or 2:
                if sn_dict.has_key("entity_" + str(event_var["userid"])):
                    if sn_dict["entity_" + str(event_var["userid"])]:
                        sn_dict["nade_nearid_" + str(event_var["userid"])] = 0
                        sn_location = es.getindexprop(sn_dict["entity_" + str(event_var["userid"])], "CBaseEntity.m_vecOrigin")
                        if sn_sticktowalls == 1:
                            es.setindexprop(sn_dict["entity_" + str(event_var["userid"])], "CBaseEntity.movetype", 0)
                        inrange(sn_location, 80, playerlib.getPlayerList('#all'), event_var["userid"])

def inrange(sn_location, sn_radius, sn_playerlist, sn_userid):
    global sn_dict
    sn_sourcelocation = vecmath.vector(sn_location)
    sn_stop = 0
    for sn_targetid in sn_playerlist:
        if sn_stop == 0:
            if (not int(sn_targetid.attributes['isdead'])) and int(sn_targetid.attributes['teamid'])>1:
                sn_targetlocation = vecmath.vector((sn_targetid.attributes['x'],
                             sn_targetid.attributes['y'],
                             sn_targetid.attributes['z']))
                sn_distance = vecmath.distance(sn_targetlocation, sn_sourcelocation)
                if sn_distance <= sn_radius:
                    sn_dict["nade_nearid_" + str(sn_userid)] = sn_targetid
                    sn_stop = 1
                    grenade_hit(int(sn_userid))

def grenade_hit(sn_userid):
    global stuck
    if sn_sticktoplayers == 1:
        sn_nadetype = sn_dict[str(sn_userid)]
        sn_entity = sn_dict["entity_" + str(sn_userid)]
        sn_nearid = int(sn_dict["nade_nearid_" + str(sn_userid)])
        sn_username = es.getplayername(sn_userid)
        sn_nearname = es.getplayername(sn_nearid)
        if sn_nadetype == 1:
            es.setindexprop(sn_entity, "CBaseCSGrenadeProjectile.baseclass.m_flDamage", sn_grenadestuckpower)
            es.setindexprop(sn_entity, "CBaseCSGrenadeProjectile.baseclass.m_DmgRadius", sn_grenadestuckradius)
            if sn_userid == sn_nearid:
                if sn_sticktothrower == 1:
                    es.msg("#multi", "#green[StickyNades]#lightgreen", sn_username, "#defaultstuck himself with a #lightgreenFrag Grenade#default!")
            else:
                es.msg("#multi", "#green[StickyNades]#lightgreen", sn_username, "#defaultstuck#lightgreen", sn_nearname, "#defaultwith a #lightgreenFrag Grenade#default!")
        if sn_nadetype == 2:
            if sn_userid == sn_nearid:
                if sn_sticktothrower == 1:
                    es.msg("#multi", "#green[StickyNades]#lightgreen", sn_username, "#defaultstuck himself with a #lightgreenFlashbang#default!")
            else:
                es.msg("#multi", "#green[StickyNades]#lightgreen", sn_username, "#defaultstuck#lightgreen", sn_nearname, "#defaultwith a #lightgreenFlashbang#default!")
        if sn_emitsounds == 1:
            if sn_userid != sn_nearid:
                es.emitsound('player', sn_userid, "stickynades/muhahaha.wav", 1, 0.5)
                es.emitsound('player', sn_nearid, "stickynades/scream.wav", 1, 0.5)
            else:
                if sn_sticktothrower == 1:
                    es.emitsound('player', sn_userid, "stickynades/scream.wav", 1, 0.5)
        if sn_shake == 1:
            if sn_userid != sn_nearid:
                shake(sn_nearid, 50, 1)
            else:
                if sn_sticktothrower == 1:
                    shake(sn_userid, 50, 1)
        if sn_userid == sn_nearid and sn_sticktothrower == 1 or sn_userid != sn_nearid:
            sn_nade = "nade" + str(sn_nearid)
            es.server.cmd("setentname %d %s" % (sn_entity, sn_nade))
            sn_user = "user" + str(sn_nearid)
            sn_user2 = "user" + str(sn_nearid)
            es.server.cmd('es_fire %s !self addoutput "targetname %s"' % (sn_nearid, sn_user))
            es.server.cmd("es_fire %s %s SetParent %s" % (sn_nearid, sn_nade, sn_user2))
            es.server.cmd("es_fire %s %s SetAnimation idle" % (sn_nearid, sn_nade))
            es.server.cmd('es_fire %s %s addoutput "angles 0 0 0"' % (sn_nearid, sn_nade))
            es.server.cmd('es_fire %s %s addoutput "solid 0"' % (sn_nearid, sn_nade))
            es.server.cmd("es_fire %s %s FireUser1" % (sn_nearid, sn_nade))
            stuck[sn_nearid] = sn_entity

def player_death(event_var):
    global stuck
    if int(event_var["userid"]) in stuck:
        es.setindexprop(stuck[int(event_var["userid"])], "CBaseEntity.movetype", -65019)
        del stuck[int(event_var["userid"])]

def shake(sn_userid, sn_magnitude, sn_time):
    if es.exists('userid', sn_userid):
        es.usermsg('create', 'shake', 'Shake')
        es.usermsg('write', 'byte', 'shake', 0)
        es.usermsg('write', 'float', 'shake', sn_magnitude)
        es.usermsg('write', 'float', 'shake', 1.0)
        es.usermsg('write', 'float', 'shake', sn_time)
        es.usermsg('send', 'shake', sn_userid)
        es.usermsg('delete','shake')